#include "Progressbar.h"
#include <cmath>
#include <iostream>
using namespace std;

Progressbar::Progressbar(int minimum, int maximum)
{
  if (minimum > maximum) {
    minimum_ = maximum;
    maximum_ = minimum;
  } else {
    minimum_ = minimum;
    maximum_ = maximum;
  }
  
  currentPosition_ = 0;
  progressbarWidth_ = 20;
}

void Progressbar::setPos(int position)
{
  position = abs(position);
  int range = getRange();
  if (0 <= position && position <= range) 
    currentPosition_ = position;
}

void Progressbar::increment(int size)
{
  if (currentPosition_ + size <= getRange())
    currentPosition_ += abs(size);
}

void Progressbar::decrement(int size)
{
  if (currentPosition_ - size >= 0) 
    currentPosition_ -= abs(size);
}

void Progressbar::print(bool first)
{ 
  int progress = static_cast<int>(floor(static_cast<double>(currentPosition_) / getRange() * progressbarWidth_));

  if (!first) 
    clearBar();

  cout << "[";
  for(int i = 0; i < progressbarWidth_; i++) {
    if (i < progress) 
      cout << "#";
    else 
      cout << "-";
  }
  cout << "]";
}

int Progressbar::getRange()
{
  return maximum_ - minimum_;
}

void Progressbar::clearBar(bool remove)
{
  for(int i = 0; i < progressbarWidth_ + 2; i++) {
    if (remove) 
      cout << "\b \b";
    else 
      cout << "\b";
  }
}